// MakeSHA1.h: CMakeSHA1 NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#pragma once

#include "MakeHashAlgorithm.h"

class CMakeSHA1 : public CMakeHashAlgorithm
{
public:
    CMakeSHA1();
    ~CMakeSHA1();

    virtual char* GetHashName(char *pBuffer=NULL) { return (pBuffer) ? strcpy(pBuffer,"SHA1") : "SHA1"; }
    virtual DWORD GetHashValueSize() { return 20; }
    virtual DWORD GetHashBlockSize() { return 64; }
    virtual void Initialize();

    virtual BOOL Test();

private:
    virtual DWORD ComputeHashHelper(const void *pBuffer, DWORD len)
            { return ComputeHashHelper(pBuffer, m_pHash, len); }
    virtual DWORD ComputeHashHelper(const void *pBuffer, void *msg_digest, DWORD len);
    virtual void ComputeHashFinalHelper(void *msg_digest);

private:
    DWORD m_pHash[5];
};
