#include "stdafx.h"

using namespace std;
using boost::lexical_cast;

const char * const CLASS_NAME = "o2on{9F88F13F-7078-43bb-822B-4AC8ED205567}";
const char * const WINDOW_TITLE = O2ON_VER_INFO;

const int NOTIFY_TRAYICON = WM_APP + 1;

HANDLE proxy_listen_thread_handle, chat_thread_handle, http_thread_handle, p2p_thread_handle;
volatile bool do_thread;
HINSTANCE instance;
HWND hwnd_main;
bool reboot_flag;

bool init_app(LPSTR cmdLine, int cmdShow);
bool end_app(void);
static LRESULT CALLBACK main_window_proc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp);
static BOOL CALLBACK exit_progress_dialogProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp);
void setTrayIcon(HWND hwnd, NOTIFYICONDATA& iconData);

extern void change_to_moduledir(void);

void output_error(const char *fmt, ...)
{
	va_list argp;
	char buf[128];

	va_start(argp, fmt);
	vsprintf(buf, fmt, argp);
	MessageBox(hwnd_main, buf, "G[", MB_ICONWARNING|MB_OK);
	va_end(argp);
}

//**************************************************************************
//*
//* WinMain
//*
//**************************************************************************
int WINAPI WinMain(HINSTANCE inst, HINSTANCE /*pinst*/, LPSTR cmdLine, int cmdShow)
{
#ifdef _DEBUG
	// ݂̃tO擾
	int dbgFlag = _CrtSetDbgFlag(_CRTDBG_REPORT_FLAG);

	// NA
	dbgFlag &= ~(_CRTDBG_ALLOC_MEM_DF | _CRTDBG_CHECK_ALWAYS_DF | _CRTDBG_CHECK_EVERY_16_DF
		| _CRTDBG_CHECK_EVERY_128_DF | _CRTDBG_CHECK_EVERY_1024_DF | _CRTDBG_DELAY_FREE_MEM_DF);

	dbgFlag |= _CRTDBG_ALLOC_MEM_DF; // `FbN
	dbgFlag |= _CRTDBG_CHECK_EVERY_1024_DF; // 1024񂲂ƂɃ`FbN

	_CrtSetDbgFlag(dbgFlag);
#endif /* #ifdef _DEBUG */

	instance = inst;
	if (!init_app(cmdLine, cmdShow))
		return FALSE;

	MSG msg;
	BOOL ret;
	while ((ret = GetMessage(&msg, NULL, 0, 0)) != 0) {
		if (ret == -1)
			break;

		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}

//**************************************************************************
//*
//* initApp
//* ݒ⃁CEBhE̍쐬Ȃ
//*
//**************************************************************************
bool init_app(LPSTR /*cmdLine*/, int /*cmdShow*/)
{
	INITCOMMONCONTROLSEX	ic;
	WNDCLASSEX				wc;
	WSADATA					wsadata;
	unsigned int			taddr;
	int						ret;
	struct stat				stbuf;

	//change_to_moduledir();

	//*****************************************************
	// RRg[̏
	//*****************************************************
	ic.dwSize = sizeof(INITCOMMONCONTROLSEX);
	ic.dwICC = ICC_INTERNET_CLASSES;
	InitCommonControlsEx(&ic);

	//*****************************************************
	// Winsock̏
	//*****************************************************
	if (WSAStartup(MAKEWORD(1, 1), &wsadata) != 0) {
		output_error("Winsock̏Ɏs܂");
		return false;
	}

	//*****************************************************
	// e평
	//*****************************************************
	// ToDo: Boostgď
	ret = stat(DATDIR, &stbuf);
	if (ret == -1 || !(stbuf.st_mode & _S_IFDIR)) {
		//datfBNg쐬
		if (mkdir(DATDIR) == -1) {
			output_error("datfBNg쐬ł܂");
			return false;
		}
	}

	//*****************************************************
	// CEBhENX̓o^
	//*****************************************************
	wc.cbSize			= sizeof(WNDCLASSEX);
	wc.style			= CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc		= main_window_proc;
	wc.cbClsExtra		= 0;
	wc.cbWndExtra		= 0;
	wc.hInstance		= instance;
	wc.hIcon			= NULL; // LoadIcon(NULL, MAKEINTRESOURCE(IDI_SMALL));
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground	= (HBRUSH)(COLOR_MENU + 1);
	wc.lpszMenuName		= NULL;
	wc.lpszClassName	= CLASS_NAME;
	wc.hIconSm			= NULL; // LoadIcon(NULL, MAKEINTRESOURCE(IDI_SMALL));

	if (!RegisterClassEx(&wc))
		return FALSE;

	//*****************************************************
	// CEBhE̍쐬
	//*****************************************************
	hwnd_main = CreateWindow(
		CLASS_NAME,
		WINDOW_TITLE,
		WS_OVERLAPPEDWINDOW | WS_CLIPSIBLINGS | WS_CLIPCHILDREN,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		640,
		480,
		NULL,
		NULL,
		instance,
		NULL);

	if (!hwnd_main)
		return FALSE;

	////*****************************************************
	//// CEBhE\
	////*****************************************************
	//change_tab(-1, current_tab);
	//ShowWindow(hwnd_main, cmdShow);
	//UpdateWindow(hwnd_main);

	//*****************************************************
	// XbhN
	//*****************************************************
	do_thread = true;
	proxy_listen_thread_handle
		= reinterpret_cast<HANDLE>(_beginthreadex(NULL, 0, proxy_listen_thread, NULL, 0, &taddr));
	p2p_thread_handle = reinterpret_cast<HANDLE>(
		_beginthreadex(NULL, 0, p2p_thread, NULL, 0, &taddr));
	chat_thread_handle = reinterpret_cast<HANDLE>(
		_beginthreadex(NULL, 0, chat_thread, NULL, 0, &taddr));
	http_thread_handle = reinterpret_cast<HANDLE>(
		_beginthreadex(NULL, 0, http_thread, NULL, 0, &taddr));

	return true;
}

//**************************************************************************
//*
//* endApp
//* AvP[V̏I
//*
//**************************************************************************
bool end_app(void)
{
	HWND	hwnd_progress;

	//vOX_CAO\
	hwnd_progress = CreateDialog(
			instance,
			MAKEINTRESOURCE(IDD_EXIT_PROGRESS),
			hwnd_main,
			exit_progress_dialogProc);
	SendMessage(GetDlgItem(hwnd_progress, IDC_PROGRESS),
			PBM_SETRANGE, 0, MAKELPARAM(0, 5));
	SendMessage(GetDlgItem(hwnd_progress, IDC_PROGRESS),
			PBM_SETSTEP, 1, 0);
	ShowWindow(hwnd_progress, SW_SHOW);
	UpdateWindow(hwnd_progress);

	//Xbh~
	do_thread = false;

	WaitForSingleObject(p2p_thread_handle, 30000);
	CloseHandle(p2p_thread_handle);
	SendMessage(GetDlgItem(hwnd_progress, IDC_PROGRESS), PBM_STEPIT, 0, 0);

	WaitForSingleObject(chat_thread_handle, 30000);
	CloseHandle(chat_thread_handle);
	SendMessage(GetDlgItem(hwnd_progress, IDC_PROGRESS), PBM_STEPIT, 0, 0);

	WaitForSingleObject(http_thread_handle, 30000);
	CloseHandle(http_thread_handle);
	SendMessage(GetDlgItem(hwnd_progress, IDC_PROGRESS), PBM_STEPIT, 0, 0);

	WaitForSingleObject(proxy_listen_thread_handle, 30000);
	CloseHandle(proxy_listen_thread_handle);
	SendMessage(GetDlgItem(hwnd_progress, IDC_PROGRESS), PBM_STEPIT, 0, 0);

	// ݒۑ
	SendMessage(GetDlgItem(hwnd_progress, IDC_PROGRESS), PBM_STEPIT, 0, 0);

	//
	WSACleanup();
	SendMessage(GetDlgItem(hwnd_progress, IDC_PROGRESS), PBM_STEPIT, 0, 0);

	DestroyWindow(hwnd_progress);
	return true;
}

//**************************************************************************
//*
//* mainWindowProc
//* CEBhẼvV[W
//*
//**************************************************************************
LRESULT CALLBACK main_window_proc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
	static UINT		taskbarCreated;
	static NOTIFYICONDATA icon_data;

	switch (msg) {
	case WM_CREATE:
		taskbarCreated = RegisterWindowMessage("TaskbarCreated");
		setTrayIcon(hwnd, icon_data);
		break;

	case NOTIFY_TRAYICON:
		// Task tray Messages
		switch (lp) {
		case WM_RBUTTONUP:
			{
				HMENU hMenu = LoadMenu(instance, MAKEINTRESOURCE(IDR_TRAYMENU));
				HMENU hSubMenu = GetSubMenu(hMenu, 0);
				POINT pt;
				GetCursorPos(&pt);
				SetForegroundWindow(hwnd);
				TrackPopupMenu(hSubMenu, TPM_BOTTOMALIGN, pt.x, pt.y, 0, hwnd, NULL);
				DestroyMenu(hMenu);
				break;
			}
		}
		break;

	case WM_COMMAND:
		switch (LOWORD(wp)) {
		case ID_SHOWGUI:
			// ToDo: |[g߂Ȃ̂Ȃ
			ShellExecute(NULL, "open", "http://127.0.0.1:50000/", NULL, NULL, SW_SHOW);
			break;

		case ID_REBOOT:
			reboot_flag = true;
			// go through 
		case ID_EXIT:
			SendMessage(hwnd, WM_CLOSE, 0, 0);
			break;

		default:
			break;
		}
		break;

	case WM_QUERYENDSESSION:
		end_app();
		return 1;

	case WM_CLOSE:
		end_app();
		DestroyIcon(icon_data.hIcon);
		Shell_NotifyIcon(NIM_DELETE, &icon_data);
		PostMessage(NULL, WM_NULL, 0, 0);
		return DefWindowProc(hwnd, msg, wp, lp);

	case WM_DESTROY:
		if (reboot_flag) {
			char path[_MAX_PATH];
			GetModuleFileName(NULL, path, _MAX_PATH);
			ShellExecute(NULL, "open", path, NULL, NULL, SW_SHOW);
		}
		PostQuitMessage(0);
		break;

	default:
		if (msg == taskbarCreated) {
			// explorerƂ̏
			setTrayIcon(hwnd, icon_data);
			break;
		} else {
			return DefWindowProc(hwnd, msg, wp, lp);
		}
	}
	return 0L;
}

void setTrayIcon(HWND hwnd, NOTIFYICONDATA& iconData)
{
	// ^XNgCɃACR\
	iconData.cbSize = sizeof iconData;
	iconData.uID = 1;
	iconData.hWnd = hwnd;
	iconData.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP;
	iconData.hIcon = reinterpret_cast<HICON>(LoadImage(instance,
		MAKEINTRESOURCE(IDI_SMALL), IMAGE_ICON, GetSystemMetrics(SM_CXSMICON),
		GetSystemMetrics(SM_CYSMICON), 0));
	iconData.uCallbackMessage = NOTIFY_TRAYICON;
	GetWindowText(hwnd, iconData.szTip, sizeof iconData.szTip / sizeof iconData.szTip[0]);
	Shell_NotifyIcon(NIM_ADD, &iconData);
}

//**************************************************************************
//*
//*
//*
//*
//**************************************************************************
BOOL CALLBACK exit_progress_dialogProc(HWND hwnd, UINT msg, WPARAM /*wp*/, LPARAM /*lp*/)
{
	RECT r1, r2;

	switch (msg) {
	case WM_INITDIALOG:
		GetWindowRect(hwnd_main, &r1);
		GetWindowRect(hwnd, &r2);
		SetWindowPos(hwnd, HWND_TOP,
			r1.left + ((r1.right-r1.left)-(r2.right-r2.left))/2,
			r1.top	+ ((r1.bottom-r1.top)-(r2.bottom-r2.top))/2,
			0, 0, SWP_NOSIZE);
		break;
/*	case WM_COMMAND:
		switch (LOWORD(wp)) {
		case IDOK:
		case IDCANCEL:
			EndDialog(hwnd, IDOK);
			break;
		default:
			return FALSE;
		}
		break;*/
	default:
		return FALSE;
	}
	return TRUE;
}
