#include "stdafx.h"

using namespace std;

namespace {
	const int maxInConnection = 16;
	const int maxOutConnection = 4;
	const int maxWaitingConnection = 2;
	const char * const p2pNodeFileName = "p2pnode.txt";
}

struct findFromAddr : public unary_function<TCPSocketBuffer<TimedTCPSocket>, bool> {
	findFromAddr(unsigned long naddr) : naddr_(naddr) {}
	bool operator()(const TCPSocketBuffer<TimedTCPSocket>& s) const
	{
		sockaddr_in sin;
		s.getpeername(reinterpret_cast<sockaddr*>(&sin));
		return sin.sin_addr.s_addr == naddr_;
	}
private:
	unsigned long naddr_;
};

unsigned int __stdcall p2p_thread(void* /*data*/)
{
	unsigned short p2p_port;
	try {
		p2p_port = boost::lexical_cast<unsigned short>(getIniString("o2on", "p2p_port", ""));
	} catch (boost::bad_lexical_cast&) {
		p2p_port = 51000;
	}

	// P2PProcessor
	P2PProcessor p2pprocessor(p2p_port);

	// P2PpserventN
	TCPServer<TCPSocketBuffer<TimedTCPSocket>, P2PProcessor>
		p2pservent(p2pprocessor, maxInConnection);
	try {
		if (!p2pservent.start(p2p_port)) {
			throw exception("P2P|[g̃I[vɎs܂\nݒύXčċNĂ");
		}
	} catch (exception& e) {
		// ƂƁc
		MessageBox(NULL, e.what(), "o2on", MB_OK);
		do_thread = false;
		return 0;
	}

	while (do_thread) {
		p2pservent.process();
	}

	return 0;
}

inline void P2PProcessor::acceptDetected()
{// Ȃ
}

inline void P2PProcessor::disconnected()
{// Ȃ
}

void P2PProcessor::dosomething(std::list<TCPSocketBuffer<TimedTCPSocket> >& sockets)
{
	time_t nowtime;
	time(&nowtime);
	if (nowtime == pretime) {
		// 1secoĂȂꍇ͉Ȃ
		return;
	} else {
		pretime = nowtime;
	}

	// 90bȏ㉽MĂȂؒf
	for (list<TCPSocketBuffer<TimedTCPSocket> >::iterator it = sockets.begin();
		it != sockets.end();
		)
	{
		if (it->getSocket().recvTimeout(90)) {
			it = server_->pop(it);
		} else {
			++it;
		}
	}

	// 60bȏ㉽MĂȂnodeꂽXML
	for (list<TCPSocketBuffer<TimedTCPSocket> >::iterator it = sockets.begin(), end = sockets.end();
		it != end;
		++it)
	{
		if (it->getSocket().sendTimeout(60)) {
			string nodesxml = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><o2on>";
			for (vector<NodeInfo>::iterator nodesit = nodes.begin();
				nodesit != nodes.end();
				++nodesit)
			{
				nodesxml += boost::str(boost::format("<nodeinfo host=\"%1%\" port=\"%2%\"/>")
					% nodesit->getHost() % nodesit->getPort());
			}
			nodesxml += "</o2on>";

			sendP2PMessage(it->getSocket(), "NODE", nodesxml);
		}
	}

	using namespace boost::lambda;

	// ڑȂꍇOɐڑ
	if (sockets.size() < maxOutConnection && nodes.size() > sockets.size()
		&& waitingSockets.size() < maxWaitingConnection) {
		// Dxق sockets.size() + 1 ̃m[h擾
		vector<NodeInfo>::iterator nth = nodes.begin() + sockets.size() + 1;
		nth_element(nodes.begin(), nth, nodes.end(),
			(bind(&NodeInfo::getPriority, _1) > bind(&NodeInfo::getPriority, _2)));

		for (vector<NodeInfo>::iterator it = nodes.begin(); it != nth; ++it) {
			if (find_if(sockets.begin(), sockets.end(), findFromAddr(it->getAddr()))
				!= sockets.end())
			{
				continue;
			}

			TCPSocket new_sock;
			new_sock.nonblocking();
			if (new_sock.connect(it->getAddr(), it->getPort())) {
				SOCKET sock = new_sock.release();
#pragma warning(push, 3)
				FD_SET(sock, &waitingFd);
#pragma warning(pop)
				waitingSockets.push_back(sock);
			}
			it->decPriority();
			break;
		}
	}

	fd_set waiting = waitingFd;
	timeval waitval = {0, 1};
	// ڑłƃnhVFCNserventɓo^
	if (select(FD_SETSIZE, NULL, &waiting, NULL, &waitval) > 0) {
		for (vector<SOCKET>::iterator it = waitingSockets.begin();
			it != waitingSockets.end();
			)
		{
			if (FD_ISSET(*it, &waiting)) {
				TCPSocket new_sock(*it);

				sockaddr_in sin;
				new_sock.getpeername(reinterpret_cast<sockaddr*>(&sin));
				vector<NodeInfo>::iterator nodesit = find_if(nodes.begin(), nodes.end(),
					bind(&NodeInfo::getAddr, _1) == sin.sin_addr.s_addr);
				if (nodesit != nodes.end()) {
					nodesit->incPriority();
				}

				// HandShake
				const char* tmp = "Hello, world!!!";
				vector<char> temp(tmp, tmp + 15);
				sendP2PMessage(new_sock, "HANDSHAKE", temp);

				server_->push(new_sock.release());
#pragma warning(push, 3)
				FD_CLR(*it, &waitingFd);
#pragma warning(pop)
				it = waitingSockets.erase(it);
			} else {
				++it;
			}
		}
	}

	// ڑɎs
	waiting = waitingFd;
	if (select(FD_SETSIZE, NULL, NULL, &waiting, &waitval) > 0) {
		for (vector<SOCKET>::iterator it = waitingSockets.begin();
			it != waitingSockets.end();
			)
		{
			if (FD_ISSET(*it, &waiting)) {
				shutdown(*it, 1);
				closesocket(*it);
#pragma warning(push, 3)
				FD_CLR(*it, &waitingFd);
#pragma warning(pop)
				it = waitingSockets.erase(it);
			} else {
				++it;
			}
		}
	}
}

bool P2PProcessor::recvDetected(TCPSocketBuffer<TimedTCPSocket>& sockbuf)
{
	if (sockbuf.getBuffer().length() > 1024 * 1024) {// 1MBɃobt@𐧌
		return false;
	}

	string& str = sockbuf.getBuffer();

	size_t pos;
	while (pos = str.find("\r\n\r\n"), strfound(pos)) {
		string header(str, 0, pos);
		istringstream iss(header);
		size_t length = 0;
		string method;
		while (iss) {
			string line;
			if (!getline(iss, line)) break;
			size_t pos = line.find(": ");
			if (!strfound(pos)) continue;
			string key(line, 0, pos);
			string value(line, pos + 2);
			if (key == "Method") {
				method = value;
			} else if (key == "Content-Length") {
				try {
					length = boost::lexical_cast<size_t>(value);
				} catch (boost::bad_lexical_cast&) {}
			}
		}
		if (str.size() < header.size() + 4 + length) return true;	// ܂S͂ĂȂ

		str.erase(0, pos + 4); // Headerobt@

		if (length == 0) return true;

		vector<char> deflateBody(str.begin(), str.begin() + length);
		str.erase(0, length);
		vector<char> body;
		if (!zlib_inflate(deflateBody, body)) {
			// 𓀎s
			return false;
		}

		string strbody(body.begin(), body.end());
		MessageBox(NULL, strbody.c_str(), "hogehoge - o2on", MB_OK);
	}

	return true;
}

void P2PProcessor::startProcessor()
{
	// Nodeǂݍ
	ifstream nodeifs(p2pNodeFileName);
	if (!nodeifs.fail()) {
		string buf;
		while (getline(nodeifs, buf), !nodeifs.fail()) {
			NodeInfo node;
			size_t pos = buf.rfind(":");
			try {
				node = NodeInfo(buf.substr(0, pos),
					boost::lexical_cast<unsigned short>(buf.substr(pos + 1)));
				nodes.insert(nodes.end(), node);
			} catch (exception&) {}
		}
	}
	//sort(nodes.begin(), nodes.end());
	//nodes.erase(unique(nodes.begin(), nodes.end()), nodes.end());
	//vector<NodeInfo>(nodes).swap(nodes);
}

P2PProcessor::~P2PProcessor()
{
	// Nodeo
	ofstream nodeofs(p2pNodeFileName);
	if (!nodeofs.fail()) {
		for (vector<NodeInfo>::iterator it = nodes.begin(), end = nodes.end();
			it != end;
			++it)
		{
			nodeofs << it->getHost() << ':' << boost::lexical_cast<string>(it->getPort()) << '\n';
		}
	}

	for (vector<SOCKET>::iterator it(waitingSockets.begin()), end(waitingSockets.end());
		it != end;
		++it)
	{
		shutdown(*it, 1);
		closesocket(*it);
	}
}

NodeInfo::NodeInfo(const std::string& host, unsigned short port)
	: host_(host), port_(port), priority(0)
{
	hostent* phostent = gethostbyname(host.c_str());
	if (!phostent)
		throw exception("Invalid Hostname");

	memcpy(&addr_, phostent->h_addr, sizeof addr_);
}

void sendP2PMessage(const TCPSocket& s, const string& method, const char* body, size_t size)
{
	vector<char> deflated;
	if (zlib_deflate(body, size, deflated)) {
		string header = "Method: " + method;
		header += "\r\nContent-Length: ";
		header += boost::lexical_cast<string>(deflated.size());
		header += "\r\n\r\n";
		s.send(header.data(), header.length());
		s.send(&deflated[0], deflated.size());
	}
}

void NodeInfos::pushNodeinfo(const NodeInfo& ni)
{
	Lock lock = cs;

	if (find(nodes.begin(), nodes.end(), ni) != nodes.end())
		return;

	nodes.push_back(ni);

	using namespace boost::lambda;
	if (nodes.size() > 100) { // 100ȏ̎͗DxႢق80܂Ō炷
		vector<NodeInfo>::iterator nth = nodes.begin() + (nodes.size() - 80);
		nth_element(nodes.begin(), nth, nodes.end(),
			(bind(&NodeInfo::getPriority, _1) < bind(&NodeInfo::getPriority, _2)));
		nodes.erase(nodes.begin(), nth);
		vector<NodeInfo>(nodes).swap(nodes);
	}
}
