#ifndef O2ON_UTILITY_H_INCLUDED
#define O2ON_UTILITY_H_INCLUDED

#include <string>
#include <boost/noncopyable.hpp>

inline bool strfound(size_t s) { return s != std::string::npos; }
void strreplace(std::string& src, const std::string& target, const std::string& str);

class CriticalSection : boost::noncopyable {
public:
	CriticalSection() { InitializeCriticalSection(&cs); }
	~CriticalSection() { DeleteCriticalSection(&cs); }
private:
	CRITICAL_SECTION cs;
	friend class Lock;
};

class Lock : boost::noncopyable {
public:
	Lock(CriticalSection& cs) : cs_(cs) { EnterCriticalSection(&cs_.cs); }
	~Lock() { LeaveCriticalSection(&cs_.cs); }
private:
	CriticalSection& cs_;
};

#endif /* O2ON_UTILITY_H_INCLUDED */
